# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# ---------------------------------------------------------------------------
# for delineation of landslide probabilities
# coded by H.I. Reuter as printed in
# Gruber et al 2008, in Hengl & Reuter [Eds] Geomorphometry DSS33 p. 419-437
# COPYRIGHT 2009 Hannes Isaak Reuter
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 C:\WorkSpace\pythontbx\d25m2_source 0.2
# Import system modules
import sys, string, os, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
#base source hlparam
# Script arguments...
Expression = sys.argv[1]
source = sys.argv[2]
hlparam = sys.argv[3]
if hlparam == '#':
    hlparam = "0.19"
# debug - needs to be at 1 and DEBUGSCRATCH variable must be set to run in DEBUG MODE
if len(sys.argv) >= 5:
    DEBUG = sys.argv[4]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace(Expression,os,gp,string,DEBUG)
sourcedem,sourceworkspace = tp.getnameandworkspace_base(source,os,gp,string,DEBUG)
gp.workspace = workspace
# Local variables...
hlparam1 = hlparam.replace('.','')
dem_fldir = dem + "fldir"
dem_fldirdeg = dem + "fldirdeg"
dem_li = dem + "li"+str(hlparam1)
dem_hi = dem + "hi"+str(hlparam1)
dem_fri = dem + "fri"+str(hlparam1)
dem_pqi = dem + "pqi"+str(hlparam1)
dem_H_L = dem + "H_L"+str(hlparam1)
dem_H_L_lim = dem + "H_L_lim"+str(hlparam1)
dem_pq_limi = dem + "pq_limi"+str(hlparam1)
dem_start_Z = dem + "start_Z"+str(hlparam1)
dem_int = dem +"int"

try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    #
    tp.gtbmsg("H/L parameter is set to ",hlparam,gp)
    if not gp.Exists(dem_fldir):
        tp.gtbmsgid(50,dem_fldir,gp)
        gp.FlowDirection_sa(dem, dem_fldir, "NORMAL", Output_drop_raster)
    else:
        tp.gtbmsgid(51,dem_fldir,gp)
    if not gp.Exists(dem_fldirdeg):
        tp.gtbmsgid(116,dem_fldirdeg,gp)
        gp.SingleOutputMapAlgebra_sa( "con ( log2 ( "+base_fldir+") < 6,( log2 ( "+base_fldir+" ) + 2) * 45, ( log2 ( "+base_fldir+") - 6 ) * 45 )", dem_fldirdeg )
    else:
        tp.gtbmsgid(117,dem_fldirdeg,gp)
        
    if not gp.Exists(dem_int):
        tp.gtbmsgid(118,dem_int,gp)
        gp.int_sa(dem, dem_int)
    else:
        tp.gtbmsgid(119,dem_int,gp)
    
    tp.getp_q_limi(source,dem,dem_fldirdeg,dem_fri,base,dem_int,dem_li,dem_pqi, dem_hi, dem_H_L, dem_H_L_lim,dem_pq_limi,gp,scratchWS)


    # clean temp files
    if DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for avalanche.py for ",dem_pq_limi,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
