# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# filter lf classification grids for single speckle cells.
#/* implements an filtering algorithm to reduce the number of
#/* misclassified relief units
#/* written by hannnes isaak reuter
#/* contact gisxperts@web.de
# C:\WorkSpace\tt\d25m2lf11 C:\WorkSpace\tt\d25m2lf11f 4 #
# C:\WorkSpace\test\d25m2_pen C:\WorkSpace\test\d25m2_penrf 3 #
# F:\jrc_d_drive\geomorphometryTB\test\ad25_lfp F:\jrc_d_drive\geomorphometryTB\test\ad25_lfp35 5 #
# F:\jrc_d_drive\geomorphometryTB\test\zwei\ad25_lfp F:\jrc_d_drive\geomorphometryTB\test\zwei\ad25_lfpf10 3 #
import sys, string, os, tempfile,  traceback
# debug
DEBUG = False
# DEBUG = True

 # Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
 import win32com.client,tp21
 gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
 import arcgisscripting
 import tp24 as tp
 gp = arcgisscripting.create()
elif version == '2.5.':
 import arcgisscripting
 import tp25 as tp
 gp = arcgisscripting.create()
elif version == '2.6.':
 import arcgisscripting
 import tp26 as tp
 gp = arcgisscripting.create()
else:
 raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
  # Script arguments...
  # &args file out method slope pennock thr1 thr2 thr3
Expression = sys.argv[1] # input dataset
dem_out = sys.argv[2]
thr1 = sys.argv[3]       # amount of numbers of cell to be replaced
leaveoutvalue = sys.argv[4]       # amount of numbers of cell to be replaced
if thr1 == '#':
      thr1 = 5
else:
      thr1 = thr1
if leaveoutvalue == '#':
      leaveoutvalue = '-9999'
else:
      leaveoutvalue = leaveoutvalue
if len(sys.argv) >= 6:
    DEBUG = sys.argv[5]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# define neighnourhood for all processes
Expression1 = 3
InNeighborhood = 'RECTANGLE ' + str(Expression1) + ' ' + str(Expression1) + ' CELL'
InNoDataOption = "DATA"
# create variables for workspace
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
# check output data exists
outdem,outworkspace = tp.checkoutput(dem_out,os,gp)
# define windows exact like the original values
gp.extent = tp.getextent(dem,gp)
# clean temp files
tp.cleanttempfile4(gp,scratchWS,workspace,os)
# local variables
tmp12345 = tp.scratchgrid(dem,scratchWS,gp)
tmp12346 = tp.scratchgrid(dem,scratchWS,gp)

# out put file name
# copy input grid to work grid - needed for loop for focal_stats
# don't use copy with copy_management.. works in Pythonwin, but not in arccatalog
try: # copy problems
      tp.gtbmsg("Start filtering with threshold of "+str(thr1)+" for Dataset ",str(dem),gp)
  # copy file into temp file
      if gp.exists(tmp12345):
             gp.delete_management(tmp12345)
      gp.SingleOutputMapAlgebra_sa( dem, tmp12345 )
  # get filter and smoothing running 
      tp.filter_lf(tmp12345,tmp12346,thr1,leaveoutvalue,gp,scratchWS)
      tp.smoothing_lf(tmp12346,tmp12345,gp,scratchWS) # input,output,gp
 # delivers tmp12345 as filled product
 # replace by original values
      if gp.Exists(dem_out):
            gp.delete_management(dem_out)
      gp.SingleOutputMapAlgebra_sa( "con( isnull( " + tmp12345 + " ) , "+dem+ " , "+tmp12345+" )", dem_out )
      if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
      gp.CheckInExtension("spatial")
     # so we see something if do error testing in idlde
      tp.gtbmsgid(25,'',gp)
      tp.gtbmsg("finished filter.py ok for "+dem+" with thr ",str(thr1),gp)

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
  # clean temp files
  tp.cleantempfile4(gp)