# ---------------------------------------------------------------------------
# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# ---------------------------------------------------------------------------
# D:\geomorphometryTB\test2\d25m2 D:\geomorphometryTB\test2\d25m2_bob D:\geomorphometryTB\source\easy\geomorphomertyTB\mcmillan_heuristicrules.txt D:\geomorphometryTB\source\easy\geomorphomertyTB\mcmillan_jmf.txt
# D:\geomorphometryTB\test2\z25m D:\geomorphometryTB\test2\z25m_bob D:\geomorphometryTB\source\easy\geomorphomertyTB\mcmillan_heuristicrules.txt D:\geomorphometryTB\source\easy\geomorphomertyTB\mcmillan_jmf.txt
# D:\geomorphometryTB\test2\z25m D:\geomorphometryTB\test2\z25m_bob D:\geomorphometryTB\source\easy\geomorphomertyTB\mcmillan_heuristicconcavtest.txt D:\geomorphometryTB\source\easy\geomorphomertyTB\mcmillan_jmfconcavtest.txt

# Import system modules
import sys, string, os, tempfile,traceback,textwrap
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
out = sys.argv[2]
heuristicfile = sys.argv[3]
jmffile = sys.argv[4]
if heuristicfile == '#':
 heuristicfiles = "macmillan_heuristicrules.txt"
if jmffile == '#':
 jmffile = "mcmillan_jmf.txt"
if not os.path.isfile(heuristicfile):
    tp.gtberrorid(10,heuristicfile,gp)
if not os.path.isfile(jmffile):
    tp.gtberrorid(11,jmffile,gp)
 # DEBUG = True
if len(sys.argv) >= 6:
    DEBUG = sys.argv[5]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_nl5metric(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(out,os,gp)
# Local variables...
#tplist = prof,slp,plan,prof,twi,pmin2max,pctz2top,pctz2str,pctz2pit,z2pit,curv
try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    heuristic=[]
    jmf=[]
# check if input grids defined in heuristic file
    heuristic,nrfuzzyparameter,jmf,nrjmfparameter = tp.macmillancheck(dem,heuristicfile,jmffile, ARCINFO,workspace,tempfile, gp,os,scratchWS)
# perform fuzzyfication of input parameters for model number 1, 4, and 5
    tp.fuzzyfy(dem,nrfuzzyparameter,heuristic,ARCINFO,workspace,tempfile, gp,os,scratchWS,textwrap)
# perform classifications
    tp.macmillanclass(dem,out,jmf,nrfuzzyparameter,heuristic,nrjmfparameter, ARCINFO,workspace,tempfile,os,gp)
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # setup clean up
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg('Finished ok for macmillan.py for '+dem+ 'and created:',out,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
