# ---------------------------------------------------------------------------
# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
# ---------------------------------------------------------------------------
# D:\geomorphometryTB\test\d25m2 D:\geomorphometryTB\test\d25m2_mey #
# d:\projects\largetest\s30eu d:\projects\largetest\s30eu #
# F:\jrc_d_drive\geomorphometryTB\test\airef F:\jrc_d_drive\geomorphometryTB\test\airefmey #
# F:\jrc_d_drive\GIS\dgm\srtm30\sr3r F:\jrc_d_drive\GIS\dgm\srtm30\sr3r_mey #
# F:\jrc_d_drive\GIS\dgm\srtm30\eud1 F:\jrc_d_drive\GIS\dgm\srtm30\eud_mey3 # #
# F:\jrc_d_drive\GIS\dgm\srtm30\sr3 F:\jrc_d_drive\GIS\dgm\srtm30\sr3_mey23 # #

def roughnessfile(workspace):
    tp.gtbmsg("Write roughness reclass file",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="0    5 : 1" ;        tmp.write(cmd+'\n')
    cmd="5   10 : 2" ;        tmp.write(cmd+'\n')
    cmd="10   20 : 3" ;        tmp.write(cmd+'\n')
    cmd="20   40 : 4" ;        tmp.write(cmd+'\n')
    cmd="40   80 : 5" ;        tmp.write(cmd+'\n')
    cmd="80  160 : 6" ;        tmp.write(cmd+'\n')
    cmd="160 10000 : 7" ;        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)
def elevationfile(workspace):
    tp.gtbmsg("Write elevation reclass file",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="-500  200 : 1" ;        tmp.write(cmd+'\n')
    cmd="200  500 : 2" ;        tmp.write(cmd+'\n')
    cmd="500 1000 : 3" ;        tmp.write(cmd+'\n')
    cmd="1000 2000 : 4" ;        tmp.write(cmd+'\n')
    cmd="2000 3000 : 5" ;        tmp.write(cmd+'\n')
    cmd="3000 4000 : 6" ;        tmp.write(cmd+'\n')
    cmd="4000 5000 : 7" ;        tmp.write(cmd+'\n')
    cmd="5000 9000 : 8" ;        tmp.write(cmd+'\n')
    cmd="9000 66000 : 0";        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)
def flowdirfile(workspace):
    tp.gtbmsg("Write flowdirection reclass file",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="1   1 : 1" ;        tmp.write(cmd+'\n')
    cmd="2   2 : 2" ;        tmp.write(cmd+'\n')
    cmd="4   4 : 1" ;        tmp.write(cmd+'\n')
    cmd="8   8 : 2" ;        tmp.write(cmd+'\n')
    cmd="16  16 : 1" ;        tmp.write(cmd+'\n')
    cmd="32  32 : 2" ;        tmp.write(cmd+'\n')
    cmd="64  64 : 1" ;        tmp.write(cmd+'\n')
    cmd="128 128 : 2" ;        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)


# Import system modules
import sys, string, os,  tempfile, traceback,textwrap
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
out = sys.argv[2]
win = sys.argv[3]
scaling = sys.argv[4]
if win == '#':
    win = "10"
# DEBUG = True
if scaling == '#':
    scaling = 5000

if len(sys.argv) >= 6:
    DEBUG = sys.argv[5]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(out,os,gp)
# Local variables...
out_e = dem+'r_e_'+str(win)
out_r = dem+'r_r_'+str(win)
out_f = dem+'r_f_'+str(win)
out_a = dem+'r_a_'+str(win)
# scaling = 60 
try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # check if DEM contains negative value.. and bail.. 
    #zmin,zmax,mean,std = tp.getelevationrange(workspace+dem,gp)
    #if zmin < 0:
    #    gp.addmessage('Minimum Elevation Data are below ZERO, please re-adjust range')
    #    raise Exception, 'Minimum Elevation Data are below ZERO, please re-adjust range, procedure not designed to work with negative values'

#/* OUTPUTS THE TYPOLOGY IN 15 CLASSES
#/* 1    plains
#/* 2    mid altitude plains
#/* 3    high altitude plains
#/* 4    lowlands
#/* 5    rugged lowlands
#/* 6    very low plateaus
#/* 7    low plateaus
#/* 8    mid altitude plateaus
#/* 9    high altitude plateaus
#/* 10   very high altitude plateaus
#/* 11   hills
#/* 12   low altitude mountains
#/* 13   mid altitude mountains
#/* 14   high altitude mountains
#/* 15   very high altitude mountains

# get roughness class file
    roughness = roughnessfile(scratchWS)

    # get elevation reclass file
    elevation = elevationfile(scratchWS)
    # get flowdir reclass file
    flowdir = flowdirfile(scratchWS)
# tbi: check for dd or projected data!!! current only dd data
# perform preparation of input parameters
    tp.meybeckprep(dem,workspace + out_e,workspace + out_r,workspace + out_f,workspace + out_a,win,scaling,roughness,elevation,flowdir,ARCINFO,workspace,scratchWS,tempfile, gp,os,textwrap)
#    tp.meybeckprep(dem,workspace + out_e,workspace + out_r,win,scaling,roughness,elevation,flowdir,ARCINFO,workspace,scratchWS,tempfile, gp,os,textwrap)
# for metric data
    # tp.meybeckprepdd(dem,win,roughness,elevation,flowdir,cell,rad,km,sqr2,ARCINFO,workspace,scratchWS,tempfile, gp,os,textwrap)
# perform classification
    if version == '2.6.':
        tp.meybeckclassnumpy(out,out_e,out_r,win,ARCINFO,workspace,tempfile,os,gp,textwrap)
    else:
        tp.meybeckclass(out,out_e,out_r,win,ARCINFO,workspace,tempfile,os,gp,textwrap)
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)    # setup clean up
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for meybeck.py for ",dem,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
