# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
##/* 	Citation:
##/* Reuter,H.I. 2004 Spatial crop and soil landscape processes under special consideration or relief information in a loess landscape.
##/* Ph-D thesis. Uni Hannover, Inst. for Soil Science, Horizonte Bd. 16
## computes monte carlo TWI
## Improvments: extended set of tp parameters
##/*C:\WorkSpace\test\d25m2 C:\WorkSpace\test\d25m2twi # # # True C:\WorkSpace\test\d25m2mspi C:\WorkSpace\test\d25m2spc
# C:\WorkSpace\test\d25m2 C:\WorkSpace\test\mwi 10 50 0.02 False # #
# F:\jrc_d_drive\geomorphometryTB\test\d25m F:\jrc_d_drive\geomorphometryTB\test\ad25mwi 10 50 0.02 False # # 1
import sys, string, os, tempfile, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# setup
if len(sys.argv) >= 10:
    DEBUG = sys.argv[9]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# Script arguments...
Expression = sys.argv[1] # input dem
output_twi = sys.argv[2] # output dem twi
outdemtwi,outworkspacetwi = tp.checkoutput(output_twi,os,gp)
std = sys.argv[3]
n = sys.argv[4]
breakvalue = sys.argv[5]
secall = sys.argv[6]
output_stc = sys.argv[7] # output dem stc
if output_stc <> '#':
    outdemstc,outworkspacestc = tp.checkoutput(output_stc,os,gp)
else:
   secall = 0
output_spi = sys.argv[8] # output dem spi
if output_spi <> '#':
    outdemspi,outworkspacespi = tp.checkoutput(output_spi,os,gp)
else:
    secall = 0
#&r montewi <inputDEM> <outputdem> <standard deviation> <number of iterations> {break}
if std == '#':
      std = float(10)
if n == '#':
      n = float(50)
#/* compute optimum break off points by dividing std / number of runs
if breakvalue == '#':
      breakvalue = float(float(std) / float(n))
if secall == '#':
      secall = 0
if secall == 'true':
      secall = 1
if secall == 'false':
      secall = 0
if secall:
      if output_stc == '#':
            tp.gtberror('Please specify STC output grid','',gp)
      if output_spi == '#':
            tp.gtberror('Please specify SPI output grid','',gp)
# how to handle nodata
InNoDataOption = "DATA"
InNeighborhood = "Rectangle 3 3 CELL"
# create variables for workspace
dem,workspace = tp.getnameandworkspace_metric(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
##
try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    ####    computation starts here
    tp.gtbmsg(" Process DEM "+dem+ " for montetwi with n:"+str(n)+' std:'+str(std)+' breakvalue at: ',str(breakvalue),gp)
    tp.getmtwi(dem,gp,output_twi,std,n,breakvalue,secall,output_stc,output_spi,scratchWS)
#### computation finish here
    gp.CheckInExtension("spatial")
      # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)         # so we see something if do error testing in idlde
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("finished montewi.py ok for ",dem,gp)
    
except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
# clean temp files

