# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# rescale.py
#
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 25
# D:\geomorphometryTB\test2\d25m2 D:\geomorphometryTB\test2\z25m 25
# Import system modules
import sys, string, os, traceback
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
out = sys.argv[2]
Expression1 = sys.argv[3]
# 25 is the parameter which has been used in the LAP-MII Report by MacMillan and Pettapiece
if Expression1 == '#':
 Expression1 = "0"
Expression2 = sys.argv[4]
# 25 is the parameter which has been used in the LAP-MII Report by MacMillan and Pettapiece
if Expression2 == '#':
 Expression2 = "25"

# DEBUG
if len(sys.argv) >= 6:
    DEBUG = sys.argv[5]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# create variables for workspace
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(out,os,gp)
try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # extended to spport negative values and specific value ranges 
    #min,max,mean,std = tp.getelevationrange(dem,gp)
    tp.getrescale2(dem,out,Expression1,Expression2,gp)
    # gp.SingleOutputMapAlgebra_sa('(( '+dem+' - '+str(min)+' ) / ('+str(max)+' - '+str(min)+' )) * '+Expression1, out)
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for rescale.py for "+dem+' into ',out,gp)
    
except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
