# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
### calculates SOTER units
##/*=========================================================================================================
##//*C:\WorkSpace\pythontbx\d25m2 C:\WorkSpace\pythontbx\a25m_soter2 # # # # # #
## get the possibility to table outside
## get the
# F:\jrc_d_drive\geomorphometryTB\test\d25 F:\jrc_d_drive\geomorphometryTB\test\d25lfsoter # # # # # #
# F:\jrc_d_drive\geomorphometryTB\test\aire F:\jrc_d_drive\geomorphometryTB\test\aire22 # # # # # #


def riclasstablewrite():
    tp.gtbmsg("Write RI class table",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="-10000 0: 0" ;        tmp.write(cmd+'\n')
    cmd=" 0 50: 1 ";        tmp.write(cmd+'\n')
    cmd=" 50 100: 2";        tmp.write(cmd+'\n')
    cmd=" 100 300: 3 ";        tmp.write(cmd+'\n')
    cmd="300 10000: 4";        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)

def slopeclasstablewrite():
    tp.gtbmsg("Write Slope class table",'',gp)
    fd, aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="-10000 0: 0" ; tmp.write(cmd+'\n')
    cmd="0 2: 1";       tmp.write(cmd+'\n')
    cmd="2 5: 2";       tmp.write(cmd+'\n')
    cmd="5 10: 3";      tmp.write(cmd+'\n')
    cmd="10 15: 4";     tmp.write(cmd+'\n')
    cmd="15 30: 5";     tmp.write(cmd+'\n')
    cmd="30 45: 6";     tmp.write(cmd+'\n')
    cmd="45 10000: 7";  tmp.write(cmd+'\n')
    tmp.close()
    return(aml)


def ppdclasstablewrite():
    tp.gtbmsg("Write PPD class table",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="-10000000 0: 0 ";        tmp.write(cmd+'\n')
    cmd="0 90: 1";        tmp.write(cmd+'\n')
    cmd="90 100000000: 2";        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)

def hypsclasstablewrite():
    tp.gtbmsg("Write Hyps class table",'',gp)
    fd,aml = tempfile.mkstemp(suffix='.txt',dir=workspace)
    tmp = os.fdopen(fd, 'w+t')
    # print aml
    cmd="-10000 0: 0";        tmp.write(cmd+'\n')
    cmd="0 10: 1";        tmp.write(cmd+'\n')
    cmd="10 50: 2";        tmp.write(cmd+'\n')
    cmd="50 100: 3";        tmp.write(cmd+'\n')
    cmd="100 200: 4";        tmp.write(cmd+'\n')
    cmd="200 300: 5";        tmp.write(cmd+'\n')
    cmd="300 600: 6";        tmp.write(cmd+'\n')
    cmd="600 1500: 7";        tmp.write(cmd+'\n')
    cmd="1500 3000: 8";        tmp.write(cmd+'\n')
    cmd="3000 5000: 9";        tmp.write(cmd+'\n')
    cmd="5000 10000: 10";        tmp.write(cmd+'\n')
    tmp.close()
    return(aml)

################################################################
##### main part starts here #################
###############################################################
import sys, string, os, tempfile, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]    # input dem
output = sys.argv[2]        # output dem
Expressionx = sys.argv[3]   # stream threshold
if Expressionx == '#':
    Expression1 = "value > 100"
else:
    Expression1 = "value > " + str(Expressionx)
thr1 = sys.argv[4]          # first filter treshold
if thr1 == '#':
    thr1 = 11
thr2 = sys.argv[5]          # second filter threshold
if thr2 == '#':
    thr2 = 3
thr3 = sys.argv[6]          # third filter threshold
if thr3 == '#':
    thr3 = 7
block = sys.argv[7]         # block threshold
if block == '#':
    block = 990
area = sys.argv[8]          # area filter threshold for hannes filter
if area == '#':
    area = 5
if len(sys.argv) >= 10:
    DEBUG = sys.argv[9]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_nl5metric(Expression,os,gp,string,DEBUG)
# set workspace
gp.workspace = workspace
out,outworkspace = tp.checkoutput(output,os,gp)
# how to handle nodata
InNoDataOption = "DATA"
# set names
hyps= dem+'_hyps'
hypsclass= dem+'_hypsc'
ppd= dem+'_ppd'
ppdclass= dem+'_ppdc'
slpp= dem+'_slpp'
slpclass = dem+'_slpc'
ri = dem+'_ri'
riclass = dem+'_ric'
dem_slpp = dem + "slpp"
dem_flacc = dem + "flacc"
dem_fldir = dem + "fldir"
dem_strnet = dem + "strnet"
Output_drop_raster = ""
ri990 = dem+'_ri'+str(block)
ppd990 = dem+'_ppd'+str(block)
slp990 = dem+'_slp'+str(block)
hyps990 = dem+'_hyps'+str(block)
purawg = dem+'_puraw'
pu = dem+'puc'
# temp file names
# cellsize = tp.getcellsize(dem,gp)
# scratchextent = str(cellsize)+' '+str(cellsize)+' '+str(3*cellsize)+' ' +str(3*cellsize)
# tmp12345 = tp.scratchgrid(dem,scratchWS,gp)
# tmp12346 = tp.scratchgrid(dem,scratchWS,gp)
# tmp12347 = tp.scratchgrid(dem,scratchWS,gp)
# tmp12348 = tp.scratchgrid(dem,scratchWS,gp)
 ### code comes from joesl aml
    #/* 1.2.1 - Compute the physiographic parameters:
    #&type  computing physiographic parameters...
    #grid
try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # define windows smaller than the original values
    gp.extent = tp.getextentforxcells(dem,-1,gp)
    tp.gtbmsg(" Process DEM "+dem+ " for SOTER ",'',gp)
    #/* 1.2.1.1 - Fill the DEM:
    #/*FILL dem hyps SINK 20
    ri_neigbh = 'CIRCLE 5 CELL'
    ppd_neigbh = 'CIRCLE 20 CELL'
    tp.soterprep(dem,dem_slpp,ri,ri_neigbh,ppd,ppd_neigbh,Expression1,gp,scratchWS)
    # now reclass all data
    tp.gtbmsg("Classify Slope ",'',gp)
    aml = slopeclasstablewrite()
    if not gp.exists(slpclass):
        gp.ReclassByASCIIFile_sa(dem_slpp, aml, slpclass, "DATA")
    if gp.exists(slpclass):
        gp.BuildRasterAttributeTable_management(slpclass,"NONE")
    tp.getaggregationsoter(slpclass,slp990,block,thr1,thr2,thr3,gp,scratchWS)
    tp.deleteaml(os,aml,gp)
    #/* 1.2.1.3 - Compute the relief intensity parameter (RI):
    tp.gtbmsg("Classify Relief Intensity",'',gp)
    #/* Relief intensity in m within a 0.5 km radius circle:
    aml = riclasstablewrite()
    if not gp.exists(riclass):
        gp.ReclassByASCIIFile_sa(ri, aml, riclass, "DATA")
    if gp.exists(riclass):
        gp.BuildRasterAttributeTable_management(riclass,"NONE")
    tp.getaggregationsoter(riclass,ri990,block,thr1,thr2,thr3,gp,scratchWS)
    tp.deleteaml(os,aml,gp)
    # /* 1.2.1.4 - Compute the potential drainage density parameter grid (PDD):
    tp.gtbmsg("Classify PPD Intensity",'',gp)
    aml = ppdclasstablewrite()
    if not gp.exists(ppdclass):
        gp.ReclassByASCIIFile_sa(ppd, aml, ppdclass, "DATA")
    if gp.exists(ppdclass):
        gp.BuildRasterAttributeTable_management(ppdclass,"NONE")
    tp.getaggregationsoter(ppdclass,ppd990,block,thr1,thr2,thr3,gp,scratchWS)
    tp.deleteaml(os,aml,gp)
    #/* 1.2.1.5 - Compute the hypsometry parameter grid (HYPS):
    tp.gtbmsg("Process Hypsometry",'',gp)
    aml = hypsclasstablewrite()
    if not gp.exists(hypsclass):
        gp.ReclassByASCIIFile_sa(dem, aml, hypsclass, "DATA")
    if gp.exists(hypsclass):
        gp.BuildRasterAttributeTable_management(hypsclass,"NONE")
    tp.getaggregationsoter(hypsclass,hyps990,block,thr1,thr2,thr3,gp,scratchWS)
    tp.deleteaml(os,aml,gp)
    # /* 1.2.2 - Build the raw SOTER Physiographic Unit (PU) polygon system (PURAW):
    tp.gtbmsg("Build SOTER Physiographic Unit",purawg,gp)
    # /* 1.2.2.1 - Combine all 4 parameter grids to build a raster of Physiographic Units:
    if gp.Exists(hyps990) and gp.Exists(ppd990) and gp.Exists(slp990) and gp.Exists(ri990):
        if gp.Exists(purawg):
            gp.delete_management(purawg)
    # replace    gp.Combine_sa('"'+'\''+workspace+hyps990+'\''+';'+'\''+workspace+ppd990+'\''+';'+'\''+workspace+slp990+'\''+';'+'\''+workspace+ri990+'\''+'"', purawg)
        gp.workspace = workspace
        gp.SingleOutputMapAlgebra_sa('( '+hyps990+' * 1000 ) + ( '+ppd990+' * 100 ) + ( '+slp990+' * 10 ) + '+ri990, purawg)
    else:
        tp.gtbmsg(" Some input data is missing: ",workspace+hyps990+' '+workspace+ppd990+' '+workspace+slp990+' '+workspace+ri990,gp)

    tp.gtbmsg("Clean raw SOTER Physiographic Unit: ",'',gp)
    if not gp.Exists(purawg):
        tp.gtbmsg(" combine grid is missing - please run manually ",'',gp)
        tp.gtbmsg(" gp.Combine_sa("+combinestring+','+ purawg+")",'',gp)
        tp.gtbmsg(" plus getcleansoter - please run manually ",'',gp)
    # run joels filter
    else:
       tp.getcleansoter(purawg,pu,thr2,thr3,gp,scratchWS)
    # /* 1.2.2.2 - Convert to raw SOTER Physiographic Unit polygons (PURAW):
    # puraw = GRIDPOLY(pu)

    if gp.Exists(pu):
      if gp.Exists(out):
            gp.delete_management(out)
      gp.rename_management(pu, out)
      tp.gtbmsg('coding is the following: hyps at the 1000 position, ppd at the 100 position, slope at 10 position and ri at the first place ','',gp)
    else:
      tp.gtbmsg("could not rename "+pu+' into ',out,gp)
      
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)

    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for soter.py for: ",out,gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)

