# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
## ---------------------------------------------------------------------------
# topo.py
# Usage: topo <Expression>
# ---------------------------------------------------------------------------
# C:\WorkSpace\test\d25m2 100 #
# C:\WorkSpace\pythontbx\d25m2 100
# F:\jrc_d_drive\geomorphometryTB\test\banjo\d1 25 1
# D:\geomorphometryTB\test\d25m 25 1
# Import system modules
import sys, string, os, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
scratchWS = ""
# Script arguments...
Expression = sys.argv[1]
Expressionx = sys.argv[2]
if Expressionx == '#':
    Expression1 = "value > 100"
else:
    Expression1 = "value > " + str(Expressionx)
if len(sys.argv) >= 4:
    DEBUG = sys.argv[3]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# create variables for workspace
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
dem,workspace = tp.getnameandworkspace_nl5metric(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
# local variables
dem_slp = dem + "slp"
dem_slp1 = dem + "slp1"
dem_asp = dem + "asp"
dem_curv = dem + "curv"
dem_prof = dem + "prof"
dem_plan = dem + "plan"
dem_bas = dem + "bas"
dem_flacc = dem + "flacc"
dem_flacc1 = dem + "flacc1"
dem_fldir = dem + "fldir"
dem_i = dem + "i"
dem_rdg = dem + "rdg"
Output_drop_raster = ""
dem_strnet = dem + "strnet"
strnetvalue = "1"
nodatavalue = "0"
dem_strlnk = dem + "strlnk"
dem_strord = dem + "strord"
dem_wshd = dem + "wshd"
dem_pour = dem + "pour"
dem_wszm = dem + "wszm"
dem_wsha = dem + "wsha"
dem_basa = dem + "basa"
nodata_slp_assignment_ = "0"
dem_wszmax = dem + "wszmax"
dem_wszmin = dem + "wszmin"
dem_pctg1 = dem + "pctg1"
dem_wi = dem + "wi"
dem_spi = dem + "spi"
dem_stc = dem + "stc"

# tmp12345 = tp.scratchgrid(dem,scratchWS,gp)
# tmp12346 = tp.scratchgrid(dem,scratchWS,gp)
# tmp12347 = tp.scratchgrid(dem,scratchWS,gp)
try:
    #clean tem p files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # define windows smaller than the original values
    gp.extent = tp.getextentminus1(dem,gp)
# get basic parameters
    tp.gtbmsg("Create the basics: aspect,slope, and curvatures for: ",dem,gp)
# Process: Aspect...
    tp.getaspect(dem,dem_asp,gp)
# Process: Slope...
    tp.getslope(dem,dem_slp,"DEGREE", "1",gp)
# Process: Curvature...
    tp.getcurvatures(dem,dem_curv,dem_prof,dem_plan,"1.0",gp,scratchWS)
    #why does the curvature command not contains all data as in grid
# check if any water parameters needs to be calculated
    tp.waterparameters(dem,Expression1,gp,scratchWS)
#  check that all watershed computations have been performed
    tp.basinparameters(dem,Expression1,gp,os,scratchWS,workspace)
# process: get ridges and thin then
    tp.getridge(dem_flacc,dem_rdg,scratchWS,gp)
# watershed stuff is done
# get invers of dem
    tp.getidem(dem,dem_i,gp,scratchWS)
# get percentage per watershed - important for simplelfabc.py
# also gets min and max grid per watershed
    tp.wshdpctg(dem,gp,os,dem_pctg1,workspace,scratchWS)
# get secondary terrain parameters
    tp.getsectp (dem,gp,dem_wi,dem_spi,dem_stc,scratchWS)
# final clean up
    gp.CheckInExtension("spatial")
    # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("finished topo.py calclation for ",dem,gp)
    
except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
