# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
#
## computes extended set of tp parameters
##/*C:\WorkSpace\pythontbx\d25m2 #
#  D:\geomorphometryTB\test2\d25mf D:\geomorphometryTB\test2\d25mf #
# F:\jrc_d_drive\geomorphometryTB\test\d25 #
# F:\jrc_d_drive\geomorphometryTB\test\banjo\d1 # 1
# F:\jrc_d_drive\geomorphometryTB\test\aire
# F:\jrc_d_drive\GIS\dgm\srtm30\eus1 F:\jrc_d_drive\GIS\dgm\srtm30\eu # 

import sys, string, os, tempfile, traceback
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
DIVVALUE = 10
scratchWS = ""
# Script arguments...
# dem outgrid method
filtereddem = sys.argv[1]
unfiltereddem = sys.argv[2]
Expressionx = sys.argv[3]
if Expressionx == '#':
    Expression1 = "value > 100"
else:
    Expression1 = "value > " + str(Expressionx)
# DEBUG = True
if len(sys.argv) >= 5:
    DEBUG = sys.argv[4]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# how to handle nodata
InNoDataOption = "DATA"
InNeighborhood = "Rectangle 3 3 CELL"
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
dem,workspace = tp.getnameandworkspace_nl5metric(filtereddem,os,gp,string,DEBUG)
gp.workspace = workspace
dem_nf,workspacenf = tp.getnameandworkspace_nl5metric(unfiltereddem,os,gp,string,DEBUG)
#invers TP parameter
dem_i = dem+'i'

# set local variables
dem_fldir = dem+'fldir'
dem_ifldir = dem+'ifldir'
dem_wshd = dem+'wshd'
dem_strnet = dem+'strnet'
dem_int = dem+'int'
dem_bas = dem+'bas'
dem_istrnet = dem_i+'strnet'

# statistics parameter
dem_wmin= dem+'wmin'
dem_wmax= dem+'wmax'
dem_bmin= dem+'bmin'
dem_bmax= dem+'bmax'

dem_iwmin= dem_i+'wmin'
dem_iwmax= dem_i+'wmax'
dem_ibmin= dem_i+'bmin'
dem_ibmax= dem_i+'bmax'

#invers parameter
dem_iwshd = dem_i+'wshd'
dem_ibas = dem_i+'bas'

# div parameter
dem_wdiv= dem+'wdiv'
dem_bdiv= dem+'bdiv'

dem_wdivz= dem+'wdivz'
dem_strz= dem+'strz'

dem_iwdiv = dem_i+'wdiv'
dem_ibdiv= dem_i+'ibdiv'
dem_iwdivd = dem_i+'wdivd'
dem_ibdivd= dem_i+'ibdivd'
dem_iwstrd = dem_i+'iwstrd'


dem_iwdivz= dem_i+'wdivz'
dem_istrz= dem_i+'strz'

dem_wdivd= dem+'wdivd'
dem_bdivd= dem+'bdivd'
dem_wstrd= dem+'wstrd'
dem_ibdivd= dem_i+'ibdivd'
# pit and peak parameters
dem_nfi = dem_nf+'i'
dem_nfflacc = dem_nf+'flacc'
dem_nffldir = dem_nf+'fldir'
dem_nfifldir = dem_nfi+'fldir'
dem_pit = dem+'pit'
dem_pitz= dem+'pitz'
dem_peak = dem+'peak'
dem_peakz= dem+'peakz'

# percentage parameters
dem_pmin2max = dem+'pmin2max'
pctz2str= dem+'pz2str'
dem_pctz2pit = dem+'pz2pit'
dem_pctz2str = dem+'pz2str'
dem_z2pit=dem+'z2pit'
dem_wpctz2top= dem+'wpz2top'
dem_bpctz2top= dem+'bpz2top'
dem_iwpctz2top= dem_i+'wpz2top'
dem_ibpctz2top= dem_i+'bpz2top'

try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    # define windows smaller than the original values
    gp.extent = tp.getextentminus1(dem,gp)
    gp.cellsize = dem
    tp.gtbmsg(" Process DEM for extended topo ",dem,gp)
    ## make sure euallocation takes flowdir/elevation into account!!!
    totalzmin,totalzmax,totalmean,totalstd = tp.getelevationrange(dem,gp)
    totalmaxmin = totalzmax - totalzmin
# mutiply by 10 so we are working as int in the dm range which should be sufficient
    tp.getint(dem,dem_int,DIVVALUE,scratchWS,gp)
    # pmin2max - PERCENCT Z TO TOTAL STUDY SITE
    tp.get100pctg(dem,str(totalzmin),str(totalmaxmin),dem_pmin2max,gp,scratchWS)
    # check if any water parameters needs to be calculated
    tp.waterparameters(dem,Expression1,gp,scratchWS)
#  check that all watershed computations have been performed
    tp.basinparameters(dem,Expression1,gp,os,scratchWS,workspace)
# make invers dem
    tp.getidem(dem,dem_i, gp,scratchWS)
    # check if any invers water parameters needs to be computed
    tp.waterparameters(dem_i,Expression1,gp,scratchWS)
#  check that all watershed computations have been performed
    tp.basinparameters(dem_i,Expression1,gp,os,scratchWS,workspace)
# get borders of watershed grid
    tp.getborder(dem_wshd,gp,dem_wdiv,scratchWS)
# get borders of basin  grid
    tp.getborder(dem_bas,gp,dem_bdiv,scratchWS)
# get borders of invers watershed grid
    tp.getborder(dem_iwshd,gp,dem_iwdiv,scratchWS)
# get borders of invers basin  grid
    tp.getborder(dem_ibas,gp,dem_ibdiv,scratchWS)
# get pits
# need flowdir from dem_nf and dem_ifldir
    tp.justflowacc(dem_nf,gp,scratchWS)
    tp.sinks(dem_nffldir, dem_pit,'',gp)
    # get peaks
    tp.getidem(dem_nf,dem_nfi,gp,scratchWS)
    tp.justflowacc(dem_nfi,gp,scratchWS)
    tp.sinks(dem_nfifldir, dem_peak,'',gp)
#perform relative and absolute TP calculations
# pctz2top - relative elevation per watershed
# now get min and max and calculate position of cell per watershed
    tp.ZonalStatistics2(dem_wshd, "VALUE", dem, workspace+dem_wmin, "MINIMUM", "DATA",gp,os,scratchWS)
    tp.ZonalStatistics2(dem_wshd, "VALUE", dem, workspace+dem_wmax, "MAXIMUM", "DATA",gp,os,scratchWS)
    tp.get100pctg(dem,dem_wmin,dem_wmax,dem_wpctz2top,gp,scratchWS)
# now get min and max and calculate position of cell per basin
    tp.ZonalStatistics2(dem_bas, "VALUE", dem, workspace+dem_bmin, "MINIMUM", "DATA",gp,os,scratchWS)
    tp.ZonalStatistics2(dem_bas, "VALUE", dem, workspace+dem_bmax, "MAXIMUM", "DATA",gp,os,scratchWS)
    tp.get100pctg(dem,dem_bmin,dem_bmax,dem_bpctz2top,gp,scratchWS)

# now get min and max and calculate position of cell per invers watershed
    tp.ZonalStatistics2(dem_iwshd, "VALUE", dem, workspace+dem_iwmin, "MINIMUM", "DATA",gp,os,scratchWS)
    tp.ZonalStatistics2(dem_iwshd, "VALUE", dem, workspace+dem_iwmax, "MAXIMUM", "DATA",gp,os,scratchWS)
    tp.get100pctg(dem,dem_iwmin,dem_iwmax,dem_iwpctz2top,gp,scratchWS)
# now get min and max and calculate position of cell per invers basin
    tp.ZonalStatistics2(dem_ibas, "VALUE", dem, workspace+dem_ibmin, "MINIMUM", "DATA",gp,os,scratchWS)
    tp.ZonalStatistics2(dem_ibas, "VALUE", dem, workspace+dem_ibmax, "MAXIMUM", "DATA",gp,os,scratchWS)
    tp.get100pctg(dem,dem_ibmin,dem_ibmax,dem_ibpctz2top,gp,scratchWS)
# /* pctz2stream - PERCENT Z TO stream /divide cell
# allocate height of nearest watershed divide to this cell
    tp.geteucalloc(dem_wdiv,dem_int,dem_wdivz,DIVVALUE,scratchWS,gp)
# allocate height of nearest stream to this cell
    tp.geteucalloc(dem_strnet,dem_int,dem_strz,DIVVALUE,scratchWS,gp)
    # calculate
    tp.get100pctg(dem,dem_strz,dem_wdivz,dem_pctz2str,gp,scratchWS)
#/* pctz2pit - PERCENT Z TO LOCAL PEAK AND PIT
# allocate height of nearest pit
    tp.geteucalloc(dem_pit,dem_int,dem_pitz,DIVVALUE,scratchWS,gp)
    # allocate height of nearest peak
    tp.geteucalloc(dem_peak,dem_int,dem_peakz,DIVVALUE,scratchWS,gp)
    # calculate
    tp.get100pctg(dem,dem_pitz,dem_peakz,dem_pctz2pit,gp,scratchWS)
# allocate height of nearest divide to this cell
#    gp.EucAllocation_sa(dem_bdiv, tmp12345,"",dem_int)
#    gp.divide_sa (tmp12345, DIVVALUE, dem_peakz)
    # allocate height of nearest divide to this cell
#    gp.EucAllocation_sa(dem_ibdiv, tmp12345,"",dem_int)
#    gp.divide_sa (tmp12345, DIVVALUE, dem_pitz)
# horizontal distance to nearest divide and stream compute
    if not gp.exists(dem_wdivd):
        gp.EucDistance_sa(dem_wdiv, dem_wdivd)
    if not gp.exists(dem_wstrd):
        gp.EucDistance_sa(dem_strnet, dem_wstrd)
    if not gp.exists(dem_bdivd):
        gp.EucDistance_sa(dem_bdiv, dem_bdivd)
    if not gp.exists(dem_ibdivd):
        gp.EucDistance_sa(dem_ibdiv, dem_ibdivd)
    if not gp.exists(dem_iwdivd):
        gp.EucDistance_sa(dem_iwdiv, dem_iwdivd)
    if not gp.exists(dem_iwstrd):
        gp.EucDistance_sa(dem_istrnet, dem_iwstrd)
    
#/* z2pit
    if not gp.exists(dem_z2pit):    
        gp.minus_sa(dem,dem_pitz,dem_z2pit)

    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)

    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,dem,gp)
    tp.gtbmsg("finished topo_extended.py ok for ",dem,gp)
#### computation finish here

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)

