# COPYRIGHT 2009 Hannes Isaak Reuter
# All rights reserved
# Contact: gisxperts@web.de
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.
# ---------------------------------------------------------------------------
# C:\WorkSpace\pythontbx\d25m2 C:\WorkSpace\pythontbx\d25m2_source 0.2
# Import system modules
# D:\geomorphometryTB\test\d25m2 D:\geomorphometryTB\test\d25m2_tpi # # # # #
# F:\jrc_d_drive\geomorphometryTB\test\d25 F:\jrc_d_drive\geomorphometryTB\test\d25tpi lfF:\jrc_d_drive\geomorphometryTB\test\d25tpi1 F:\jrc_d_drive\geomorphometryTB\test\d25tpi2 # # # # # # # # 
import sys, string, os, traceback,tempfile,textwrap
# Create the Geoprocessor object
version = sys.version[0:4]
if version == '2.1.':
    import win32com.client,tp21
    gp = win32com.client.Dispatch("esriGeoprocessing.GpDispatch.1")
elif version == '2.4.':
    import arcgisscripting
    import tp24 as tp
    gp = arcgisscripting.create()
elif version == '2.5.':
    import arcgisscripting
    import tp25 as tp
    gp = arcgisscripting.create()
elif version == '2.6.':
    import arcgisscripting
    import tp26 as tp
    gp = arcgisscripting.create()
else:
    raise Exception, 'Version not yet supported'

ARCGIS = ""
ARCINFO = ""
# Script arguments...
Expression = sys.argv[1]
outfile = sys.argv[2]
outfile1 = sys.argv[3]
outfile2 = sys.argv[4]
inner = sys.argv[5]
if inner == '#':
 inner = "5"
outer = sys.argv[6]
if outer == '#':
 outer = "10"
inner1 = sys.argv[7]
if inner1 == '#':
 inner1 = "50"
outer1 = sys.argv[8]
if outer1 == '#':
 outer1 = "55"
slp_thr = sys.argv[9]
if slp_thr == '#':
 slp_thr = 5
std_thr = sys.argv[10]
if std_thr == '#':
 std_thr = 1
if len(sys.argv) >= 12:
    DEBUG = sys.argv[11]
    if DEBUG == '#':
        DEBUG = 0
else:
    DEBUG = 0
# setup
ARCGIS,ARCINFO,scratchWS = tp.geomorphometrysetup(gp,sys,os,DEBUG)
# create variables for workspace
dem,workspace = tp.getnameandworkspace_base(Expression,os,gp,string,DEBUG)
gp.workspace = workspace
outdem,outworkspace = tp.checkoutput(outfile,os,gp)
outdem,outworkspace = tp.checkoutput_report(outfile1,os,gp)
outdem,outworkspace = tp.checkoutput_report(outfile2,os,gp)
# Local variables...
dem_slp = dem + "slp"
dem_tpi = dem + "tpi"
try:
    # clean temp files
    tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.Extent = tp.getextentforxcells(dem,0,gp)
    tp.gtbmsg("Small Nbgh Inner and outer parameter are set to "+inner+' and '+outer,'',gp)
    if not gp.exists(outfile1):
        tp.gettpi(dem,outfile1,inner,outer,'MEAN',gp,scratchWS)
    tp.gtbmsg("Large Nbgh Inner and Outer parameter are set to "+inner1+' and '+outer1,'',gp)
    if not gp.exists(outfile2):
        tp.gettpi(dem,outfile2,inner1,outer1,'MEAN',gp,scratchWS)
    #/* slope for backslope classifications
    tp.getslope(dem,dem_slp,"DEGREE","1",gp)
    # /* get TPI parameters
    gp.Extent = tp.getextentforxcells(dem,outer1,gp)
    if gp.Exists(outfile):
          gp.delete_management(outfile)
    zmin,zmax,mean,std_inner = tp.getelevationrange(outfile1,gp)
    std05_inner = std_thr * std_inner
    zmin,zmax,mean,std_inner1 = tp.getelevationrange(outfile2,gp)
    std05_inner1 = std_thr * std_inner1
    if version == '2.6.':
        tp.lfweiss2numpy(std05_inner,std05_inner1,outfile1,outfile2,outfile,dem_slp,slp_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
    else:
        tp.lfweiss2(std05_inner,std05_inner1,outfile1,outfile2,outfile,dem_slp,slp_thr,ARCINFO,workspace,tempfile,gp,os,textwrap)
   # clean temp files
    if not DEBUG :
        tp.cleanttempfile4(gp,scratchWS,workspace,os)
    gp.Extent = tp.getextentforxcells(dem,0,gp)
    gp.CheckInExtension("spatial")
    tp.gtbmsgid(25,'',gp)
    tp.gtbmsg("Finished ok for tpi_weiss.py for "+dem+' and outfile: '+outfile,'',gp)
    

except:
##/* ######################################################
##/* routine bailout start
##/* ######################################################
  tp.errorcall(sys,gp,traceback)
